/*
 *************************************************************************
 * Ralink Tech Inc.
 * 5F., No.36, Taiyuan St., Jhubei City,
 * Hsinchu County 302,
 * Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2007, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 *************************************************************************

    Module Name:
    debug.h

    Abstract:

    Revision History:
    Who         When          What
    --------    ----------    ----------------------------------------------
	Eddy Tsai	01-12-2008    Created
*/
#ifndef	__DEBUG_H__
#define	__DEBUG_H__


/*  Lower values indicate higher urgency */
#define DEBUG_OFF        0
#define DEBUG_ERROR      1
#define DEBUG_WARN       2
#define DEBUG_TRACE      3
#define DEBUG_INFO       4
#define DEBUG_LOUD       5

extern LONG DEBUG_TX_Level;
extern LONG DEBUG_RX_Level;
extern LONG DEBUG_MAC_Level;

#define DBGPRINT_TX(Level, Fmt)    	\
{                                   \
    if ((Level) <= DEBUG_TX_Level)  \
    {                               \
        printk Fmt;					\
    }                               \
}

#define DBGPRINT_RX(Level, Fmt)    	\
{                                   \
    if ((Level) <= DEBUG_RX_Level)  \
    {                               \
        printk Fmt;					\
    }                               \
}

#define DBGPRINT_MAC(Level, Fmt)    \
{                                   \
    if ((Level) <= DEBUG_MAC_Level) \
    {                               \
        printk Fmt;					\
    }                               \
}

#endif /* __DEBUG_H__ */

