/*
 *************************************************************************
 * Ralink Tech Inc.
 * 5F., No.36, Taiyuan St., Jhubei City,
 * Hsinchu County 302,
 * Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2007, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 *************************************************************************

    Module Name:
    rt_config.h

    Abstract:
	Linux device driver for Ralink 802.11 wireless devices based on mac80211 stack

    Revision History:
    Who         When          What
    --------    ----------    ----------------------------------------------
	Eddy Tsai	01-12-2008    Support rt2860 PCI card
*/
#ifndef	__RT_CONFIG_H__
#define	__RT_CONFIG_H__

#include <linux/skbuff.h>
#include <linux/etherdevice.h>
#include <linux/pci.h>
#include <linux/interrupt.h> 
#include <net/mac80211.h>

#define DRIVER_VERSION		"2.0-GPL"
#ifdef RT2860
#define DEVICE_NAME			"RT2860"
#endif /* RT2860 */

/* Native type definition */
typedef char			CHAR;
typedef short			SHORT;
typedef int				INT;
typedef long			LONG;

typedef int				INT32;

typedef unsigned char	BOOLEAN;
typedef unsigned short	USHORT;
typedef unsigned char	UCHAR;
typedef unsigned int	UINT;
typedef unsigned long	ULONG;
typedef unsigned char	UINT8;
typedef unsigned short	UINT16;
typedef unsigned int	UINT32;
typedef unsigned long	UINT64;

#include    "debug.h"
#include    "rtmp.h"
#ifdef RT2860
#include	"rt2860pci.h"
#endif /* RT2860 */

#endif /* __RT_CONFIG_H__ */

