/*
 *************************************************************************
 * Ralink Tech Inc.
 * 5F., No.36, Taiyuan St., Jhubei City,
 * Hsinchu County 302,
 * Taiwan, R.O.C.
 *
 * (c) Copyright 2002-2007, Ralink Technology, Inc.
 *
 * This program is free software; you can redistribute it and/or modify  * 
 * it under the terms of the GNU General Public License as published by  * 
 * the Free Software Foundation; either version 2 of the License, or     * 
 * (at your option) any later version.                                   * 
 *                                                                       * 
 * This program is distributed in the hope that it will be useful,       * 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        * 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         * 
 * GNU General Public License for more details.                          * 
 *                                                                       * 
 * You should have received a copy of the GNU General Public License     * 
 * along with this program; if not, write to the                         * 
 * Free Software Foundation, Inc.,                                       * 
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             * 
 *                                                                       * 
 *************************************************************************

    Module Name:
    rtmp_init.c

    Abstract:

    Revision History:
    Who         When          What
    --------    ----------    ----------------------------------------------
	Eddy Tsai	01-12-2008    Created
*/
#include "rt_config.h"
#include "firmware.h"

typedef struct  _RTMP_REG_PAIR
{
	ULONG   Register;
	ULONG   Value;
} RTMP_REG_PAIR, *PRTMP_REG_PAIR;

RTMP_REG_PAIR	MACRegTable[] =	{
	{BCN_OFFSET0,		0xf8f0e8e0},
	{BCN_OFFSET1,		0x6f77d0c8},
	{LEGACY_BASIC_RATE,	0x0000013f},
	{HT_BASIC_RATE,		0x00008003},
	{MAC_SYS_CTRL,		0x00000000},
	{RX_FILTR_CFG,		0x00017f97},
	{BKOFF_SLOT_CFG,	0x00000209},
	{TX_SW_CFG0,		0x00000000},
	{TX_SW_CFG1,		0x00080606},
	{TX_LINK_CFG,		0x00001020},
	{TX_TIMEOUT_CFG,	0x000a2090},
	{MAX_LEN_CFG,		MAX_AGGREGATION_SIZE | 0x00001000},
	{LED_CFG,			0x7f031e46},
	{PBF_MAX_PCNT,		0x1F3FBF9F},
	{TX_RTY_CFG,		0x47d01f0f},
	{AUTO_RSP_CFG,		0x00000013},
	{CCK_PROT_CFG,		0x05740003},
	{OFDM_PROT_CFG,		0x05740003},
	{GF20_PROT_CFG,		0x01744004},
	{GF40_PROT_CFG,		0x03F44084},    
	{MM20_PROT_CFG,		0x01744004},    
	{MM40_PROT_CFG,		0x03F54084},	
	{TXOP_CTRL_CFG,		0x0000583f},
	{TX_RTS_CFG,		0x00092b20},	
	{EXP_ACK_TIME,		0x002400ca},
	{TXOP_HLDR_ET, 		0x00000002},
	{XIFS_TIME_CFG,		0x33a41010},
	{PWR_PIN_CFG,		0x00000003},
};

RTMP_REG_PAIR	STAMACRegTable[] =	{
	{WMM_AIFSN_CFG,		0x00002273},
	{WMM_CWMIN_CFG,		0x00002344},
	{WMM_CWMAX_CFG,		0x000034aa},
};

typedef struct  _REG_PAIR
{
	UCHAR   Register;
	UCHAR   Value;
} REG_PAIR, *PREG_PAIR;

REG_PAIR   BBPRegTable[] = {
	{65,	0x2C},
	{66,	0x38},
	{69,	0x12},
	{70,	0x0A},
	{73,	0x10},
	{81,	0x37},
	{82,	0x62},
	{83,	0x6A},
	{84,	0x99},
	{86,	0x00},
	{91,	0x04},
	{92,	0x00},
	{103,  	0x00},
	{105,	0x05},
};

/* Reset the RFIC setting to new series */
/*	ch	    R1 	   	    R2 		 R3(TX0~4=0)     R4 */
RTMP_RF_REGS RF2850RegTable[] = {
	{1,  0x98402ecc, 0x984c0786, 0x9816b455, 0x9800510b},
	{2,  0x98402ecc, 0x984c0786, 0x98168a55, 0x9800519f},
	{3,  0x98402ecc, 0x984c078a, 0x98168a55, 0x9800518b},
	{4,  0x98402ecc, 0x984c078a, 0x98168a55, 0x9800519f},
	{5,  0x98402ecc, 0x984c078e, 0x98168a55, 0x9800518b},
	{6,  0x98402ecc, 0x984c078e, 0x98168a55, 0x9800519f},
	{7,  0x98402ecc, 0x984c0792, 0x98168a55, 0x9800518b},
	{8,  0x98402ecc, 0x984c0792, 0x98168a55, 0x9800519f},
	{9,  0x98402ecc, 0x984c0796, 0x98168a55, 0x9800518b},
	{10, 0x98402ecc, 0x984c0796, 0x98168a55, 0x9800519f},
	{11, 0x98402ecc, 0x984c079a, 0x98168a55, 0x9800518b},
	{12, 0x98402ecc, 0x984c079a, 0x98168a55, 0x9800519f},
	{13, 0x98402ecc, 0x984c079e, 0x98168a55, 0x9800518b},
	{14, 0x98402ecc, 0x984c07a2, 0x98168a55, 0x98005193},
	// 802.11 UNI / HyperLan 2
	{36, 0x98402ecc, 0x984c099a, 0x98158a55, 0x980ed1a3},
	{38, 0x98402ecc, 0x984c099e, 0x98158a55, 0x980ed193},
	{40, 0x98402ec8, 0x984c0682, 0x98158a55, 0x980ed183},
	{44, 0x98402ec8, 0x984c0682, 0x98158a55, 0x980ed1a3},
	{46, 0x98402ec8, 0x984c0686, 0x98158a55, 0x980ed18b},
	{48, 0x98402ec8, 0x984c0686, 0x98158a55, 0x980ed19b},
	{52, 0x98402ec8, 0x984c068a, 0x98158a55, 0x980ed193},
	{54, 0x98402ec8, 0x984c068a, 0x98158a55, 0x980ed1a3},
	{56, 0x98402ec8, 0x984c068e, 0x98158a55, 0x980ed18b},
	{60, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed183},
	{62, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed193},
	{64, 0x98402ec8, 0x984c0692, 0x98158a55, 0x980ed1a3}, // Plugfest#4, Day4, change RFR3 left4th 9->5.
	// 802.11 HyperLan 2
	{100, 0x98402ec8, 0x984c06b2, 0x98178a55, 0x980ed783},
	// 2008.04.30 modified 
	// The system team has AN to improve the EVM value 
	// for channel 102 to 108 for the RT2850/RT2750 dual band solution.
	{102, 0x98402ec8, 0x985c06b2, 0x98578a55, 0x980ed793},
	{104, 0x98402ec8, 0x985c06b2, 0x98578a55, 0x980ed1a3},
	{108, 0x98402ecc, 0x985c0a32, 0x98578a55, 0x980ed193},
	{110, 0x98402ecc, 0x984c0a36, 0x98178a55, 0x980ed183},
	{112, 0x98402ecc, 0x984c0a36, 0x98178a55, 0x980ed19b},
	{116, 0x98402ecc, 0x984c0a3a, 0x98178a55, 0x980ed1a3},
	{118, 0x98402ecc, 0x984c0a3e, 0x98178a55, 0x980ed193},
	{120, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed183},
	{124, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed193},
	{126, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed15b}, // 0x980ed1bb->0x980ed15b required by Rory 20070927
	{128, 0x98402ec4, 0x984c0382, 0x98178a55, 0x980ed1a3},
	{132, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed18b},
	{134, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed193},
	{136, 0x98402ec4, 0x984c0386, 0x98178a55, 0x980ed19b},
	{140, 0x98402ec4, 0x984c038a, 0x98178a55, 0x980ed183},
	// 802.11 UNII
	{149, 0x98402ec4, 0x984c038a, 0x98178a55, 0x980ed1a7},
	{151, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed187},
	{153, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed18f},
	{157, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed19f},
	{159, 0x98402ec4, 0x984c038e, 0x98178a55, 0x980ed1a7},
	{161, 0x98402ec4, 0x984c0392, 0x98178a55, 0x980ed187},
	{165, 0x98402ec4, 0x984c0392, 0x98178a55, 0x980ed197},
	// Japan
	{184, 0x95002ccc, 0x9500491e, 0x9509be55, 0x950c0a0b},
	{188, 0x95002ccc, 0x95004922, 0x9509be55, 0x950c0a13},
	{192, 0x95002ccc, 0x95004926, 0x9509be55, 0x950c0a1b},
	{196, 0x95002ccc, 0x9500492a, 0x9509be55, 0x950c0a23},
	{208, 0x95002ccc, 0x9500493a, 0x9509be55, 0x950c0a13},
	{212, 0x95002ccc, 0x9500493e, 0x9509be55, 0x950c0a1b},
	{216, 0x95002ccc, 0x95004982, 0x9509be55, 0x950c0a23},
	// still lack of MMAC(Japan) ch 34,38,42,46
};

#define	NUM_MAC_REG_PARMS	(sizeof(MACRegTable) / sizeof(RTMP_REG_PAIR))
#define	NUM_STA_MAC_REG_PARMS	(sizeof(STAMACRegTable) / sizeof(RTMP_REG_PAIR))
#define	NUM_BBP_REG_PARMS	(sizeof(BBPRegTable) / sizeof(REG_PAIR))


void RT28XXDMADisable(RTMP_ADAPTER *pAd)
{
	WPDMA_GLO_CFG_STRUC     GloCfg;

	DBGPRINT_MAC(DEBUG_TRACE, ("--->RT28XXDMADisable\n"));
	
	RTMP_IO_READ32(pAd, WPDMA_GLO_CFG, &GloCfg.word);
	GloCfg.word &= 0xff0;
	GloCfg.field.EnTXWriteBackDDONE =1;
	RTMP_IO_WRITE32(pAd, WPDMA_GLO_CFG, GloCfg.word);

	DBGPRINT_MAC(DEBUG_TRACE, ("<---RT28XXDMADisable\n"));
} /* End of RT28XXDMADisable */


void RT28XXDMAEnable(RTMP_ADAPTER *pAd)
{
	WPDMA_GLO_CFG_STRUC	GloCfg;
	int i = 0;
	
	DBGPRINT_MAC(DEBUG_TRACE, ("--->RT28XXDMAEnable\n"));

	RTMP_IO_WRITE32(pAd, MAC_SYS_CTRL, 0x4);
	do
	{
		RTMP_IO_READ32(pAd, WPDMA_GLO_CFG, &GloCfg.word);
		if ((GloCfg.field.TxDMABusy == 0)  && (GloCfg.field.RxDMABusy == 0))
			break;
		
		RTMPusecDelay(1000);
		i++;
	}while (i < 200);

	RTMPusecDelay(50);
	
	GloCfg.field.EnTXWriteBackDDONE = 1;
	GloCfg.field.WPDMABurstSIZE = 2;
	GloCfg.field.EnableRxDMA = 1;
	GloCfg.field.EnableTxDMA = 1;

	RTMP_IO_WRITE32(pAd, WPDMA_GLO_CFG, GloCfg.word);
	DBGPRINT_MAC(DEBUG_TRACE, ("<---RT28XXDMAEnable\n"));	
} /* End of RT28XXDMAEnable */


UINT NICLoadFirmware(PRTMP_ADAPTER pAd)
{
	UINT			Status = 0x00;
	UCHAR			*pFirmwareImage;
	ULONG			FileLength, Index;
	UINT32			MacReg = 0;
	ULONG			i, firm;										

	DBGPRINT_MAC(DEBUG_TRACE, ("--->NICLoadFirmware\n"));
	
	pFirmwareImage = FirmwareImage;
	FileLength = sizeof(FirmwareImage);

	RTMP_IO_WRITE32(pAd, PBF_SYS_CTRL, 0x10000);																	
	for(i=0; i< FileLength; i+=4)
	{															
		firm = pFirmwareImage[i] + (pFirmwareImage[i+3] << 24) +	\
		   (pFirmwareImage[i+2] << 16) + (pFirmwareImage[i+1] << 8);							
		RTMP_IO_WRITE32(pAd, FIRMWARE_IMAGE_BASE + i, firm);	
	}

	RTMP_IO_WRITE32(pAd, PBF_SYS_CTRL, 0x00000);
	RTMP_IO_WRITE32(pAd, PBF_SYS_CTRL, 0x00001);
																
	/* initialize BBP R/W access agent */						
	RTMP_IO_WRITE32(pAd, H2M_BBP_AGENT, 0);
	RTMP_IO_WRITE32(pAd, H2M_MAILBOX_CSR, 0);


	/* check if MCU is ready */
	Index = 0;
	do
	{
		RTMP_IO_READ32(pAd, PBF_SYS_CTRL, &MacReg);

		if (MacReg & 0x80)
			break;
		
		RTMPusecDelay(1000);
	} while (Index++ < 100);

    if (Index >= 100)
	{
		Status = 0x01;
		DBGPRINT_MAC(DEBUG_ERROR, ("NICLoadFirmware: MCU is not ready\n"));
	} /* End of if */

	DBGPRINT_MAC(DEBUG_TRACE, ("<---NICLoadFirmware\n"));
    return Status;
} /* End of NICLoadFirmware */


int	NICInitializeAsic(PRTMP_ADAPTER pAd,BOOLEAN bHardReset)
{
	ULONG			Index = 0;
	UCHAR			R0 = 0xff;
	UINT32			MacCsr12 = 0, Counter = 0;
	USHORT			KeyIdx;
	UINT32 			csr;
	INT32			i;
	WPDMA_GLO_CFG_STRUC	GloCfg;
	DELAY_INT_CFG_STRUC	IntCfg;

	DBGPRINT_MAC(DEBUG_TRACE, ("--->NICInitializeAsic\n"));	

	RTMP_IO_WRITE32(pAd, PWR_PIN_CFG, 0x3);
	if (bHardReset == TRUE) {
		RTMP_IO_WRITE32(pAd, MAC_SYS_CTRL, 0x3);
	} else {
		RTMP_IO_WRITE32(pAd, MAC_SYS_CTRL, 0x1);
	}

	RTMP_IO_WRITE32(pAd, MAC_SYS_CTRL, 0x0);
	/* Initialize MAC register to default value */
	for (Index = 0; Index < NUM_MAC_REG_PARMS; Index++)
	{
		RTMP_IO_WRITE32(pAd, MACRegTable[Index].Register, 
			MACRegTable[Index].Value);
	} /* End for loop NUM_MAC_REG_PARMS */

	for (Index = 0; Index < NUM_STA_MAC_REG_PARMS; Index++)
	{
		RTMP_IO_WRITE32(pAd, STAMACRegTable[Index].Register, 
			STAMACRegTable[Index].Value);
	} /* End for loop NUM_STA_MAC_REG_PARMS */

	/* Before program BBP, we need to wait BBP/RF get wake up. */
	Index = 0;
	do
	{
		RTMP_IO_READ32(pAd, MAC_STATUS_CFG, &MacCsr12);
		if ((MacCsr12 & 0x03) == 0)	// if BB.RF is stable
			break;
		
		DBGPRINT_MAC(DEBUG_INFO, 
			("Check MAC_STATUS_CFG  = Busy = %x\n", MacCsr12));
		RTMPusecDelay(1000);
	} while (Index++ < 100);
	
    /* The commands to firmware should be after these commands, these commands will init firmware */
	/* PCI and USB are not the same because PCI driver needs to wait for PCI bus ready */
	RTMP_IO_WRITE32(pAd, H2M_BBP_AGENT, 0);	// initialize BBP R/W access agent
	RTMP_IO_WRITE32(pAd, H2M_MAILBOX_CSR, 0);
	RTMPusecDelay(1000);

	/* Read BBP register, make sure BBP is up and running before write new data */
	Index = 0;
	do 
	{
		RTMP_BBP_IO_READ8_BY_REG_ID(pAd, 0, &R0);
		DBGPRINT_MAC(DEBUG_INFO, ("BBP version = %x\n", R0));
	} while ((++Index < 20) && ((R0 == 0xff) || (R0 == 0x00)));

	if ((R0 == 0xff) || (R0 == 0x00))
		return NDIS_STATUS_FAILURE;

	/* Initialize BBP register to default value */
	for (Index = 0; Index < NUM_BBP_REG_PARMS; Index++)
	{
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 
			BBPRegTable[Index].Register, BBPRegTable[Index].Value);
	}
	
	/* for rt2860E and after, init BBP_R84 with 0x19. This is for extension channel overlapping IOT. */
	if ((pAd->MACVersion & 0xffff) != 0x0101)
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 84, 0x19);

	if (pAd->MACVersion == 0x28600100)
	{
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 69, 0x16);
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 73, 0x12);
    }
	
	if (pAd->MACVersion >= RALINK_2880E_VERSION 
		&& pAd->MACVersion < RALINK_3070_VERSION) // 3*3
	{
		RTMP_IO_READ32(pAd, MAX_LEN_CFG, &csr);
		csr &= 0xFFF;
		csr |= 0x2000;
		RTMP_IO_WRITE32(pAd, MAX_LEN_CFG, csr);
	}

	/* Clear raw counters */
	RTMP_IO_READ32(pAd, RX_STA_CNT0, &Counter);
	RTMP_IO_READ32(pAd, RX_STA_CNT1, &Counter);
	RTMP_IO_READ32(pAd, RX_STA_CNT2, &Counter);
	RTMP_IO_READ32(pAd, TX_STA_CNT0, &Counter);
	RTMP_IO_READ32(pAd, TX_STA_CNT1, &Counter);
	RTMP_IO_READ32(pAd, TX_STA_CNT2, &Counter);
	
	// ASIC will keep garbage value after boot
	// Clear all seared key table when initial
	// This routine can be ignored in radio-ON/OFF operation. 
	if (bHardReset)
	{
		for (KeyIdx = 0; KeyIdx < 4; KeyIdx++)
		{
			RTMP_IO_WRITE32(pAd, SHARED_KEY_MODE_BASE + 4*KeyIdx, 0);
		}
		/* Clear all pairwise key table when initial */
		for (KeyIdx = 0; KeyIdx < 256; KeyIdx++)
		{
			RTMP_IO_WRITE32(pAd, 
				MAC_WCID_ATTRIBUTE_BASE + (KeyIdx * HW_WCID_ATTRI_SIZE), 1);
		}
	}
	

	/* for rt2860E and after, init TXOP_CTRL_CFG with 0x583f. This is for extension channel overlapping IOT.*/
	if ((pAd->MACVersion&0xffff) != 0x0101)
		RTMP_IO_WRITE32(pAd, TXOP_CTRL_CFG, 0x583f);

	/* Write AC_BK base address register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR1, pAd->TxRing[QID_AC_BK].Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR1 : 0x%x\n", 
		pAd->TxRing[QID_AC_BK].Cell[0].AllocPa));
	/* Write AC_BE base address register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR0, pAd->TxRing[QID_AC_BE].Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR0 : 0x%x\n", 
		pAd->TxRing[QID_AC_BE].Cell[0].AllocPa));
	/* Write AC_VI base address register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR2, pAd->TxRing[QID_AC_VI].Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR2 : 0x%x\n", 
		pAd->TxRing[QID_AC_VI].Cell[0].AllocPa));
	/* Write AC_VO base address register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR3, pAd->TxRing[QID_AC_VO].Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR3 : 0x%x\n", 
		pAd->TxRing[QID_AC_VO].Cell[0].AllocPa));
	/* Write HCCA base address register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR4, pAd->TxRing[QID_HCCA].Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR4 : 0x%x\n", 
		pAd->TxRing[QID_HCCA].Cell[0].AllocPa));
	/* Write MGMT_BASE_CSR register */
	RTMP_IO_WRITE32(pAd, TX_BASE_PTR5, pAd->MgmtRing.Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> TX_BASE_PTR5 : 0x%x\n", 
		pAd->MgmtRing.Cell[0].AllocPa));	
	/* Write RX_BASE_CSR register */
	RTMP_IO_WRITE32(pAd, RX_BASE_PTR, pAd->RxRing.Cell[0].AllocPa);
	DBGPRINT_MAC(DEBUG_INFO, ("--> RX_BASE_PTR : 0x%x\n", 
		pAd->RxRing.Cell[0].AllocPa));

	/* Init TX rings index pointer */
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX1 ,  pAd->TxRing[QID_AC_BK].TxCpuIdx);
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX0 ,  pAd->TxRing[QID_AC_BE].TxCpuIdx);
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX2 ,  pAd->TxRing[QID_AC_VI].TxCpuIdx);
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX3 ,  pAd->TxRing[QID_AC_VO].TxCpuIdx);
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX4 ,  pAd->TxRing[QID_HCCA].TxCpuIdx);
	RTMP_IO_WRITE32(pAd, TX_CTX_IDX5 ,  pAd->MgmtRing.TxCpuIdx);
	
	/*Init RX Ring index pointer */
	RTMP_IO_WRITE32(pAd, RX_CRX_IDX, pAd->RxRing.RxCpuIdx);

	/*Write TX_RING_CSR0 register */
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT0, TX_RING_SIZE);
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT1, TX_RING_SIZE);
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT2, TX_RING_SIZE);
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT3, TX_RING_SIZE);
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT4, TX_RING_SIZE);
	RTMP_IO_WRITE32(pAd, TX_MAX_CNT5, MGMT_RING_SIZE);

	/* Write RX_RING_CSR register */
	RTMP_IO_WRITE32(pAd, RX_MAX_CNT, RX_RING_SIZE);

	/* Set DMA global configuration except TX_DMA_EN and RX_DMA_EN bits:*/
	i = 0;
	do
	{
		RTMP_IO_READ32(pAd, WPDMA_GLO_CFG, &GloCfg.word);
		if ((GloCfg.field.TxDMABusy == 0)  && (GloCfg.field.RxDMABusy == 0))
			break;
		
		RTMPusecDelay(1000);
		i++;
	} while ( i < 100);

	GloCfg.word &= 0xff0;
	GloCfg.field.EnTXWriteBackDDONE =1;
	RTMP_IO_WRITE32(pAd, WPDMA_GLO_CFG, GloCfg.word);
	
	IntCfg.word = 0;
	RTMP_IO_WRITE32(pAd, DELAY_INT_CFG, IntCfg.word);


	DBGPRINT_MAC(DEBUG_TRACE, ("<---NICInitializeAsic\n"));	
	return NDIS_STATUS_SUCCESS;
} /* End of NICInitializeAsic */


void NICInitAsicFromEEPROM(PRTMP_ADAPTER pAd)
{
	UCHAR	BBPR1 = 0; 
	UCHAR	BBPR3 = 0;
	USHORT	i;
	EEPROM_ANTENNA_STRUC		Antenna;
	EEPROM_NIC_CONFIG2_STRUC	NicConfig2;
	UCHAR BbpRegIdx, BbpValue;

	DBGPRINT_MAC(DEBUG_TRACE, ("--->NICInitAsicFromEEPROM\n"));	
	for(i = 3; i < NUM_EEPROM_BBP_PARMS; i++)
	{
		if ((pAd->EEPROMDefaultValue[i] != 0xFFFF) 
			&& (pAd->EEPROMDefaultValue[i] != 0))
		{
			BbpRegIdx = (UCHAR)(pAd->EEPROMDefaultValue[i] >> 8);
			BbpValue  = (UCHAR)(pAd->EEPROMDefaultValue[i] & 0xff);
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, BbpRegIdx, BbpValue);
		}
	}

	Antenna.word = pAd->Antenna.word;
	pAd->RfIcType = (UCHAR) Antenna.field.RfIcType;

	NicConfig2.word = pAd->EEPROMDefaultValue[1];

	if ((NicConfig2.word & 0x00ff) == 0xff)
		NicConfig2.word &= 0xff00;

	if ((NicConfig2.word >> 8) == 0xff)
		NicConfig2.word &= 0x00ff;

	/* Save the antenna for future use */
	pAd->NicConfig2.word = NicConfig2.word;

	/* Turn off patching for cardbus controller */
	if (NicConfig2.field.DynamicTxAgcControl == 1)
		pAd->bAutoTxAgcA = pAd->bAutoTxAgcG = TRUE;
	else
		pAd->bAutoTxAgcA = pAd->bAutoTxAgcG = FALSE;
	
	RTMP_BBP_IO_READ8_BY_REG_ID(pAd, 3, &BBPR3);
	BBPR3 &= (~0x18);
	if(pAd->Antenna.field.RxPath == 3)
	{
		BBPR3 |= (0x10);
	} else if(pAd->Antenna.field.RxPath == 2) {
		BBPR3 |= (0x8);
	} else if(pAd->Antenna.field.RxPath == 1) {
		BBPR3 |= (0x0);
	}
	RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 3, BBPR3);

	/* Handle the difference when 1T */
	RTMP_BBP_IO_READ8_BY_REG_ID(pAd, 1, &BBPR1);
	if(pAd->Antenna.field.TxPath == 1)
	{
		BBPR1 &= (~0x18);
	}
	RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 1, BBPR1);

	DBGPRINT_MAC(DEBUG_INFO, ("TxPath = %d, RxPath = %d, RFIC=%d\n", 
		pAd->Antenna.field.TxPath, pAd->Antenna.field.RxPath, pAd->RfIcType));

	DBGPRINT_MAC(DEBUG_TRACE, ("<--->NICInitAsicFromEEPROM\n"));		
} /* End of NICInitAsicFromEEPROM */


void RTMPSetAGCInitValue(PRTMP_ADAPTER pAd,UCHAR BandWidth)
{
	UCHAR	R66 = 0x30;
	
	if (pAd->LatchRfRegs.Channel <= 14)
	{	// BG band
		R66 = 0x2E + GET_LNA_GAIN(pAd);
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 66, R66);
	}
	else
	{	//A band
		if (BandWidth == BW_20)
		{
			R66 = (UCHAR)(0x32 + (GET_LNA_GAIN(pAd)*5)/3);
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 66, R66);
		}
	}
} /* End of RTMPSetAGCInitValue */


void AsicSwitchChannel(PRTMP_ADAPTER pAd, int Channel,BOOLEAN bScan) 
{
	ULONG	R2 = 0, R3 = DEFAULT_RF_TX_POWER, R4 = 0;
	CHAR    TxPwer = 0, TxPwer2 = DEFAULT_RF_TX_POWER;
	int	index;
	UINT32 	Value = 0;
	RTMP_RF_REGS *RFRegTable;

	DBGPRINT_MAC(DEBUG_TRACE, ("--->AsicSwitchChannel\n"));

	for (index = 0; index < MAX_NUM_OF_CHANNELS; index++)
	{
		if (Channel == pAd->TxPower[index].Channel)
		{
			TxPwer = pAd->TxPower[index].Power;
			TxPwer2 = pAd->TxPower[index].Power2;
			break;
		}
	}

	if (index == MAX_NUM_OF_CHANNELS)
	{
		DBGPRINT_MAC(DEBUG_ERROR, 
			("AsicSwitchChannel: Cant find the Channel#%d \n", Channel));
	}

	RFRegTable = RF2850RegTable;

	switch (pAd->RfIcType)
	{
		case RFIC_2820:
		case RFIC_2850:
		case RFIC_2720:
		case RFIC_2750:
			for (index = 0; index < (sizeof(RF2850RegTable)/sizeof(RTMP_RF_REGS)); index++)
			{
				if (Channel == RFRegTable[index].Channel)
				{
					R2 = RFRegTable[index].R2;
					if (pAd->Antenna.field.TxPath == 1)
						R2 |= 0x4000;	// If TXpath is 1, bit 14 = 1;

					if (pAd->Antenna.field.RxPath == 2)
					{
						R2 |= 0x40;	// write 1 to off Rxpath.
					} else if (pAd->Antenna.field.RxPath == 1) {
						R2 |= 0x20040;	// write 1 to off RxPath
					}

					if (Channel > 14)
					{
						// initialize R3, R4
						R3 = (RFRegTable[index].R3 & 0xffffc1ff);
						R4 = (RFRegTable[index].R4 & (~0x001f87c0)) | (pAd->RfFreqOffset << 15);

						// 5G band power range: 0xF9~0X0F, TX0 Reg3 bit9/TX1 Reg4 bit6="0" means the TX power reduce 7dB
						// R3
						if ((TxPwer >= -7) && (TxPwer < 0))
						{
							TxPwer = (7+TxPwer);
							TxPwer = (TxPwer > 0xF) ? (0xF) : (TxPwer);
							R3 |= (TxPwer << 10);
							DBGPRINT_MAC(DEBUG_TRACE, 
								("AsicSwitchChannel: TxPwer=%d \n", TxPwer));
						} else {
							TxPwer = (TxPwer > 0xF) ? (0xF) : (TxPwer);
							R3 |= (TxPwer << 10) | (1 << 9);
						}

						// R4
						if ((TxPwer2 >= -7) && (TxPwer2 < 0))
						{
							TxPwer2 = (7+TxPwer2);
							TxPwer2 = (TxPwer2 > 0xF) ? (0xF) : (TxPwer2);
							R4 |= (TxPwer2 << 7);
							DBGPRINT_MAC(DEBUG_TRACE, 
								("AsicSwitchChannel: TxPwer2=%d \n", TxPwer2));							
						} else {
							TxPwer2 = (TxPwer2 > 0xF) ? (0xF) : (TxPwer2);
							R4 |= (TxPwer2 << 7) | (1 << 6);
						}                        
					} else {
						R3 = (RFRegTable[index].R3 & 0xffffc1ff) | (TxPwer << 9); // set TX power0
						R4 = (RFRegTable[index].R4 & (~0x001f87c0)) | (pAd->RfFreqOffset << 15) | (TxPwer2 <<6);// Set freq Offset & TxPwr1
					}

					// Based on BBP current mode before changing RF channel.
					if (!bScan && (pAd->BBPCurrentBW == BW_40))
						R4 |=0x200000;

					/* Update variables */
					pAd->LatchRfRegs.Channel = Channel;
					pAd->LatchRfRegs.R1 = RFRegTable[index].R1;
					pAd->LatchRfRegs.R2 = R2;
					pAd->LatchRfRegs.R3 = R3;
					pAd->LatchRfRegs.R4 = R4;

					/* Set RF value 1's set R3[bit2] = [0] */
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R1);
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R2);
					RTMP_RF_IO_WRITE32(pAd, (pAd->LatchRfRegs.R3 & (~0x04)));
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R4);
					RTMPusecDelay(200);

					/* Set RF value 2's set R3[bit2] = [1] */
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R1);
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R2);
					RTMP_RF_IO_WRITE32(pAd, (pAd->LatchRfRegs.R3 | 0x04));
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R4);
					RTMPusecDelay(200);

					/* Set RF value 3's set R3[bit2] = [0] */
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R1);
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R2);
					RTMP_RF_IO_WRITE32(pAd, (pAd->LatchRfRegs.R3 & (~0x04)));
					RTMP_RF_IO_WRITE32(pAd, pAd->LatchRfRegs.R4);
				}			
			}
			break;
		default:
			break;
	}

	/* Change BBP setting during siwtch from a->g, g->a */
	if (Channel <= 14)
	{
	    ULONG	TxPinCfg = 0x00050F0A;
		
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 62, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 63, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 64, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 86, 0);

		// Rx High power VGA offset for LNA select
	    if (pAd->NicConfig2.field.ExternalLNAForG)
	    {
	        RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 82, 0x62);
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 75, 0x46);
	    } else {
	        RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 82, 0x84);
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 75, 0x50);
	    }

		// 5G band selection PIN, bit1 and bit2 are complement
		RTMP_IO_READ32(pAd, TX_BAND_CFG, &Value);
		Value &= (~0x6);
		Value |= (0x04);
		RTMP_IO_WRITE32(pAd, TX_BAND_CFG, Value);

        // Turn off unused PA or LNA when only 1T or 1R
		if (pAd->Antenna.field.TxPath == 1)
		{
			TxPinCfg &= 0xFFFFFFF3;
		}
		if (pAd->Antenna.field.RxPath == 1)
		{
			TxPinCfg &= 0xFFFFF3FF;
		}

		RTMP_IO_WRITE32(pAd, TX_PIN_CFG, TxPinCfg);
	}
	else
	{
	    ULONG	TxPinCfg = 0x00050F05;
		
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 62, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 63, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 64, (0x37 - GET_LNA_GAIN(pAd)));
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 86, 0);
		RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 82, 0xF2);

		// Rx High power VGA offset for LNA select
		if (pAd->NicConfig2.field.ExternalLNAForA) {
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 75, 0x46);
		} else {
			RTMP_BBP_IO_WRITE8_BY_REG_ID(pAd, 75, 0x50);
		}

		// 5G band selection PIN, bit1 and bit2 are complement
		RTMP_IO_READ32(pAd, TX_BAND_CFG, &Value);
		Value &= (~0x6);
		Value |= (0x02);
		RTMP_IO_WRITE32(pAd, TX_BAND_CFG, Value);

        // Turn off unused PA or LNA when only 1T or 1R
		if (pAd->Antenna.field.TxPath == 1)
		{
			TxPinCfg &= 0xFFFFFFF3;
		}
		if (pAd->Antenna.field.RxPath == 1)
		{
			TxPinCfg &= 0xFFFFF3FF;
		}

		RTMP_IO_WRITE32(pAd, TX_PIN_CFG, TxPinCfg);
	}

	if (bScan)
		RTMPSetAGCInitValue(pAd, BW_20);
	else
		RTMPSetAGCInitValue(pAd, pAd->BBPCurrentBW);

	RTMPusecDelay(1000);  

	DBGPRINT_MAC(DEBUG_INFO, ("SwitchChannel#%d(RF=%d, Pwr0=%lu, Pwr1=%lu, %dT) to , R1=0x%08lx, R2=0x%08lx, R3=0x%08lx, R4=0x%08lx\n",
							  Channel, 
							  pAd->RfIcType, 
							  (R3 & 0x00003e00) >> 9,
							  (R4 & 0x000007c0) >> 6,
							  pAd->Antenna.field.TxPath,
							  pAd->LatchRfRegs.R1, 
							  pAd->LatchRfRegs.R2, 
							  pAd->LatchRfRegs.R3, 
							  pAd->LatchRfRegs.R4));

	DBGPRINT_MAC(DEBUG_TRACE, ("<---AsicSwitchChannel\n"));
} /* End of AsicSwitchChannel */


BOOLEAN AsicSendCommandToMcu(PRTMP_ADAPTER pAd,UCHAR Command,UCHAR Token,UCHAR Arg0,UCHAR Arg1)
{
	HOST_CMD_CSR_STRUC	H2MCmd;
	H2M_MAILBOX_STRUC	H2MMailbox;
	ULONG				i = 0;

	do
	{
		RTMP_IO_READ32(pAd, H2M_MAILBOX_CSR, &H2MMailbox.word);
		if (H2MMailbox.field.Owner == 0)
			break;

		RTMPusecDelay(2);
	} while(i++ < 100);

	if (i >= 100)
	{
		DBGPRINT_MAC(DEBUG_ERROR, ("H2M_MAILBOX still hold by MCU. command fail\n"));
		return FALSE;
	}

	H2MMailbox.field.Owner	  = 1;
	H2MMailbox.field.CmdToken = Token;
	H2MMailbox.field.HighByte = Arg1;
	H2MMailbox.field.LowByte  = Arg0;
	RTMP_IO_WRITE32(pAd, H2M_MAILBOX_CSR, H2MMailbox.word);

	H2MCmd.word 			  = 0;
	H2MCmd.field.HostCommand  = Command;
	RTMP_IO_WRITE32(pAd, HOST_CMD_CSR, H2MCmd.word);
	
	return TRUE;
} /* End of AsicSendCommandToMcu */


CHAR ConvertToRssi(PRTMP_ADAPTER pAd, CHAR Rssi, UCHAR RssiNumber)
{
	UCHAR	RssiOffset, LNAGain;

	// Rssi equals to zero should be an invalid value
	if (Rssi == 0)
		return -99;

	LNAGain = GET_LNA_GAIN(pAd);
    if (pAd->LatchRfRegs.Channel > 14)
    {
        if (RssiNumber == 0)
			RssiOffset = pAd->ARssiOffset0;
		else if (RssiNumber == 1)
			RssiOffset = pAd->ARssiOffset1;
		else
			RssiOffset = pAd->ARssiOffset2;
    }
    else
    {
        if (RssiNumber == 0)
			RssiOffset = pAd->BGRssiOffset0;
		else if (RssiNumber == 1)
			RssiOffset = pAd->BGRssiOffset1;
		else
			RssiOffset = pAd->BGRssiOffset2;
    }
	
    return (-12 - RssiOffset - LNAGain - Rssi);
} /* End of ConvertToRssi */


UINT ConvertRssiToSignalQuality(UINT rssi)
{
    UINT signal_quality;
    if (rssi >= -50)
        signal_quality = 100;
    else if (rssi >= -80)
        signal_quality = (UINT) (24 + ((rssi + 80) * 26)/10);
    else if (rssi >= -90)   // between -80 ~ -90dbm
        signal_quality = (UINT) ((rssi + 90) * 26)/10;
    else    // < -84 dbm
        signal_quality = 0;
 
    return signal_quality;
} /* End of ConvertRssiToSignalQuality */

